declare type ResponseConverter = (xhr: XMLHttpRequest, options: HttpOptions) => any;
interface HttpOptions {
    user?: string;
    password?: string;
    headers?: {
        [key: string]: string;
    };
    data?: any;
    responseConverter?: ResponseConverter;
    json?: boolean;
    crossDomain?: boolean;
    withCredentials?: boolean;
}
interface HttpResponse {
    data: any;
    options: HttpOptions;
    status: number;
    statusText: string;
    contentType: string | null;
}
export declare function init(method: string, url: string, options: HttpOptions): PromiseLike<HttpResponse>;
export declare function get(url: string, options?: HttpOptions): PromiseLike<HttpResponse>;
export declare function post(url: string, data: any, options?: HttpOptions): PromiseLike<HttpResponse>;
export {};
