import { Callback } from '../base';
export interface HTMLElement {
    [key: string]: any;
}
export declare type ControlEventObject = {
    type: string;
    handler: Function;
    element: HTMLElement;
};
export interface ControlOptions {
    onReady?: Callback<ControlBase>;
}
export declare abstract class ControlBase {
    _eventsCollection: ControlEventObject[];
    protected $element: HTMLElement;
    protected $options: ControlOptions;
    protected $guid: string;
    constructor(element: HTMLElement, options: ControlOptions);
    dispose(): void;
    private _ensureUniqueInstancePerType;
    protected abstract $initialize(): void;
    $registerControl(): void;
    $invoke(callback: Function | undefined, ...args: any[]): any;
    $addEvent(type: string, handler: Function, element?: HTMLElement): void;
    $removeEvent(type: string, handler: Function, element?: HTMLElement): void;
}
