import { ControlBase, ControlOptions } from './ControlBase';
import { CallbackArgs, ElementDimension } from '../base';
export interface LimiterOptions extends ControlOptions {
    position?: string;
    template?: string;
    timeout?: number;
    offsetX?: number;
    offsetY?: number;
    preserve?: boolean;
    showOnFocus?: boolean;
    root?: string;
    onCreate?: CallbackArgs<Limiter, {
        tooltip: HTMLElement;
    }>;
    onShow?: CallbackArgs<Limiter, {
        tooltip: HTMLElement;
    }>;
    onHide?: CallbackArgs<Limiter, {
        tooltip: HTMLElement;
    }>;
    onChange?: CallbackArgs<Limiter, {
        tooltip: HTMLElement;
    }>;
}
export declare type ElementPositionCalculation = {
    x: (rect: ClientRect, size: ElementDimension) => number;
    y: (rect: ClientRect, size: ElementDimension) => number;
};
export declare class Limiter extends ControlBase {
    _position: ElementPositionCalculation;
    _templateContent: string;
    _tooltip: HTMLElement | null;
    _timer: number | null;
    _root: Element | null;
    $element: HTMLInputElement | HTMLTextAreaElement;
    $options: LimiterOptions;
    constructor(element: HTMLInputElement | HTMLTextAreaElement, options: LimiterOptions);
    $initialize(): void;
    dispose(): void;
    private _setRoot;
    private _destroy;
    private _getTooltip;
    private _registerEvents;
    private _onWindowScrollOrResize;
    private _onFocusEvent;
    private _onInputEvent;
    private _onBlurEvent;
    private _updatePosition;
    private _configPosition;
    static from(selector: string, options: LimiterOptions): Limiter[];
}
