import { ControlBase, ControlOptions } from './ControlBase';
import { CallbackArgs } from '../base';
declare type MaskEditTranslation = {
    test: RegExp | {
        (value: string): boolean;
    };
    transform?: (value: string) => string;
};
export interface MaskEditOptions extends ControlOptions {
    format: string;
    placeholder?: string;
    allowPartial?: boolean;
    shifter?: string;
    translation?: {
        [key: string]: MaskEditTranslation;
    };
    onUpdate?: CallbackArgs<MaskEdit, {
        value: string;
        rawValue: string;
    }>;
}
export declare class MaskEdit extends ControlBase {
    _maskWithShifter: string;
    _originalMaxLength: number;
    _currentFormat: string;
    _translations: {
        [key: string]: {
            test: (value: string) => boolean;
            transform?: (value: string) => string;
        };
    };
    _formats: string[];
    $element: HTMLInputElement;
    $options: MaskEditOptions;
    constructor(element: HTMLInputElement, options: MaskEditOptions);
    update(): void;
    getRawValue(): string;
    setOptions(options: MaskEditOptions): void;
    dispose(): void;
    $initialize(): void;
    private _setOptionsInternal;
    private _applyMask;
    private _replace;
    private _hasTranslation;
    private _defineFormat;
    private _configOptions;
    private _normalizeTranslations;
    private _registerEvents;
    private _onBlurEvent;
    private _onInputEvent;
    private _onKeyDownEvent;
    private _getMaskWithShifter;
    private _default;
    private _deleteHandler;
    private _backspaceHandler;
    private _setCaretPosition;
    private _getCaretPosition;
    private _setValue;
    static from(selector: string, options: MaskEditOptions): MaskEdit[];
}
export {};
