import { ControlBase, ControlOptions } from './ControlBase';
import { CallbackArgs } from '../base';
export interface NumericBoxOptions extends ControlOptions {
    scale?: number;
    decimalSeparator?: string;
    groupingSeparator?: string;
    format?: string | string[];
    placeholder?: string;
    nullable?: boolean;
    min?: number;
    max?: number;
    onChange?: CallbackArgs<NumericBox, {
        value: number;
        inputValue: number;
    }>;
    onFormat?: CallbackArgs<NumericBox, {
        value: number;
        text: string;
    }>;
}
export declare class NumericBox extends ControlBase {
    $element: HTMLInputElement;
    $options: NumericBoxOptions;
    private _dataFormat;
    constructor(element: HTMLInputElement, options: NumericBoxOptions);
    $initialize(): void;
    format(): void;
    getRawValue(): string;
    private _normalizeFormat;
    private _registerEvents;
    private _onKeyDownEvent;
    private _onFocusEvent;
    private _onChangeEvent;
    private _ensureRange;
    static from(selector: string, options: NumericBoxOptions): NumericBox[];
}
