import { ControlBase, ControlOptions } from './ControlBase';
import { CallbackArgs, Callback } from '../base';
export interface SearchBoxOptions extends ControlOptions {
    template: string;
    activeItemClass?: string;
    delay?: number;
    source?: string | any[] | {
        (value: string): PromiseLike<any>;
    };
    matchesTemplate?: string;
    fieldTemplate?: string;
    maxResults?: number;
    minLength?: number;
    offsetX?: number;
    offsetY?: number;
    dataRoot?: string;
    noRecordsTemplate?: string;
    searchFields?: string[];
    onBeforeRequest?: Callback<SearchBox>;
    onAfterRequest?: CallbackArgs<SearchBox, {
        container: HTMLElement;
        data: any[];
    }>;
    onResultsRender?: CallbackArgs<SearchBox, {
        container: HTMLElement;
    }>;
    onItemSelected?: CallbackArgs<SearchBox, {
        data: any;
        text: string;
    }>;
    onActiveItem?: CallbackArgs<SearchBox, {
        data: any;
        text: string;
    }>;
    root?: string;
}
export declare class SearchBox extends ControlBase {
    private _sourceHandler;
    private _timer;
    private _searchFields;
    private _dataFilter;
    private _noRecords;
    private _itemTemplate;
    private _containerBody;
    private _container;
    private _root;
    $element: HTMLInputElement;
    $options: SearchBoxOptions;
    constructor(element: HTMLInputElement, options: SearchBoxOptions);
    $initialize(): void;
    private _setRoot;
    private _createTemplate;
    private _renderNoRecords;
    private _staticSourceHandler;
    private _readData;
    private _httpSourceHandler;
    private _promiseSourceHandler;
    private _normalizeValue;
    private _resetContainerBody;
    private _render;
    private _defineDataFilter;
    private _stringDataFilter;
    private _objectDataFilter;
    private _defineSourceHandler;
    private _selectItem;
    private _registerEvents;
    private _keyboardNavigate;
    private _updateContainerScrollPosition;
    private _onWindowScrollOrResize;
    private _onKeyDownEvent;
    private _onInputEvent;
    private _onBlurEvent;
    private _updateContainerStyle;
    private _registerContainerEvents;
    private _onItemMouseEnterEvent;
    private _onItemClick;
    static from(selector: string, options: SearchBoxOptions): SearchBox[];
}
