import { Converter } from "./base";
export declare function merge(target: any, ...sources: any[]): any;
export declare function isDefined(value: any): boolean;
export declare function isJsonLike(value: string): boolean;
export declare function isFunction(value: any): value is Function;
export declare function isString(value: any): value is string;
/**
 * Determines whether a reference is an object.
 * Unlike the `typeof` in javascript, `null` values are not considered objects.
 * @param value
 */
export declare function isObject(value: any): value is object;
/**
 * Determines whether a reference is a valid number.
 *
 * Unlike the `typeof` in JavaScript, the special numeric values `NaN`, `Inifity` and `-Infinity` are not considered as valid numbers.
 * @param value Reference to check.
 */
export declare function isNumber(value: any): value is number;
export declare function template(format: string, data: any, prefix?: string, suffix?: string): string;
export declare function toQuery(obj: any, keyEncoding?: Converter<string, any>, valueEncoding?: Converter<string, any>): string;
export declare function fromQuery(query: string, keyEncoding?: Converter<string, any>, valueEncoding?: Converter<string, any>): any;
export declare function titleCase(value: string): string;
export declare function noDiacritics(value: string): string;
